Index: usr.bin/xlint/lint1/cgram.y
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/cgram.y,v
retrieving revision 1.6
diff -u -r1.6 cgram.y
--- usr.bin/xlint/lint1/cgram.y	7 Jul 2004 12:26:51 -0000	1.6
+++ usr.bin/xlint/lint1/cgram.y	25 Dec 2006 09:50:08 -0000
@@ -1,4 +1,5 @@
 %{
+/*	$OpenBSD: cgram.y,v 1.20 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: cgram.y,v 1.8 1995/10/02 17:31:35 jpo Exp $	*/
 
 /*
@@ -31,7 +32,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: cgram.y,v 1.8 1995/10/02 17:31:35 jpo Exp $
  * $DragonFly: src/usr.bin/xlint/lint1/cgram.y,v 1.6 2004/07/07 12:26:51 asmodai Exp $
  */
 
@@ -105,7 +105,7 @@
 /* types (char, int, short, long, unsigned, signed, float, double, void) */
 %token	<y_tspec>	T_TYPE
 
-/* qualifiers (const, volatile) */
+/* qualifiers (const, volatile, restrict) */
 %token	<y_tqual>	T_QUAL
 
 /* struct or union */
@@ -128,6 +128,8 @@
 %token			T_BREAK
 %token			T_RETURN
 %token			T_ASM
+%token			T_LEQUAL
+%token			T_ATTRIBUTE
 
 %left	T_COMMA
 %right	T_ASSIGN T_OPASS
@@ -213,7 +215,7 @@
 		if (sflag) {
 			/* empty translation unit */
 			error(272);
-		} else if (!tflag) {
+		} else {
 			/* empty translation unit */
 			warning(272);
 		}
@@ -235,23 +237,49 @@
 		glclup(0);
 		clrwflgs();
 	  }
-	;
+	| T_LEQUAL T_LPARN identifier T_COMMA identifier T_RPARN T_SEMI {
+		sym_t *new, *old;
 
-data_def:
-	  T_SEMI {
-		if (sflag) {
-			/* syntax error: empty declaration */
-			error(0);
-		} else if (!tflag) {
-			/* syntax error: empty declaration */
-			warning(0);
+		if ($5->sb_sym && $3->sb_sym /*== NULL*/) {
+			new = getsym($5);
+			old = $3->sb_sym;
+			new->s_dpos = old->s_dpos;
+			new->s_spos = old->s_spos;
+			new->s_upos = old->s_upos;
+			new->s_kind = old->s_kind;
+			new->s_keyw = old->s_keyw;
+			new->s_field = old->s_field;
+			new->s_set = old->s_set;
+			new->s_used = old->s_used;
+			new->s_arg = old->s_arg;
+			new->s_reg = old->s_reg;
+			new->s_defarg = old->s_defarg;
+			new->s_rimpl = old->s_rimpl;
+			new->s_osdef = old->s_osdef;
+			new->s_inline = old->s_inline;
+			new->s_def = old->s_def;
+			new->s_scl = old->s_scl;
+			new->s_blklev = old->s_blklev;
+			new->s_type = old->s_type;
+			new->s_value = old->s_value;
+			new->u = old->u;
+
+			/* XXX missing 'r' because do not know return type
+			   of parent... */
+			/* outsym(new, new->s_scl, DEF); */
+			outfdef(new, &csrc_pos,
+			    new->s_rimpl || new->s_type->t_subt->t_tspec != VOID,
+			    0, NULL);
 		}
 	  }
+	;
+
+data_def: T_SEMI
 	| clrtyp deftyp notype_init_decls T_SEMI {
 		if (sflag) {
 			/* old style declaration; add "int" */
 			error(1);
-		} else if (!tflag) {
+		} else {
 			/* old style declaration; add "int" */
 			warning(1);
 		}
@@ -275,7 +303,7 @@
 			warning(2);
 		}
 	  }
-	| declspecs deftyp type_init_decls T_SEMI
+	| declspecs deftyp type_init_decls opt_attribute_spec T_SEMI
 	| error T_SEMI {
 		globclup();
 	  }
@@ -310,6 +338,11 @@
 	  }
 	;
 
+opt_attribute_spec:
+	/* empty */
+	| T_ATTRIBUTE T_LPARN T_LPARN read_until_rparn T_RPARN
+	;
+
 func_decl:
 	  clrtyp deftyp notype_decl {
 		$$ = $3;
@@ -706,13 +739,6 @@
 		$$ = $1;
 	  }
 	| enums T_COMMA {
-		if (sflag) {
-			/* trailing "," prohibited in enum declaration */
-			error(54);
-		} else {
-			/* trailing "," prohibited in enum declaration */
-			warning(54);
-		}
 		$$ = $1;
 	  }
 	;
@@ -756,7 +782,7 @@
 	;
 
 notype_init_decl:
-	  notype_decl opt_asm_spec {
+	  notype_decl opt_attribute_spec opt_asm_spec {
 		idecl($1, 0);
 		chksz($1);
 	  }
@@ -1004,7 +1030,7 @@
 		if (sflag) {
 			/* ANSI C requires formal parameter before "..." */
 			error(84);
-		} else if (!tflag) {
+		} else {
 			/* ANSI C requires formal parameter before "..." */
 			warning(84);
 		}
@@ -1052,9 +1078,7 @@
 
 opt_asm_spec:
 	  /* empty */
-	| T_ASM T_LPARN T_STRING T_RPARN {
-		freeyyv(&$3, T_STRING);
-	  }
+	| T_ASM T_LPARN read_until_rparn
 	;
 
 initializer:
@@ -1067,6 +1091,7 @@
 	  }
 	| init_lbrace init_expr_list init_rbrace
 	| init_lbrace init_expr_list T_COMMA init_rbrace
+	| init_lbrace init_rbrace
 	| error
 	;
 
@@ -1176,6 +1201,14 @@
 		label(T_CASE, NULL, $2);
 		ftflg = 1;
 	  }
+	| T_CASE constant T_ELLIPSE constant T_COLON {
+		/* XXX: only using the first value of this gcc-ism */
+		label(T_CASE, NULL, $2);
+		ftflg = 1;
+
+		if (!gflag)
+			gnuism(311);
+	  }
 	| T_DEFAULT T_COLON {
 		label(T_DEFAULT, NULL, NULL);
 		ftflg = 1;
@@ -1440,7 +1473,7 @@
 
 term:
 	  T_NAME {
-		/* XXX realy neccessary? */
+		/* XXX really necessary? */
 		if (yychar < 0)
 			yychar = yylex();
 		$$ = getnnode(getsym($1), yychar);
@@ -1472,10 +1505,6 @@
 		$$ = build($1, $2, NULL);
 	  }
 	| T_ADDOP term {
-		if (tflag && $1 == PLUS) {
-			/* unary + is illegal in traditional C */
-			warning(100);
-		}
 		$$ = build($1 == PLUS ? UPLUS : UMINUS, $2, NULL);
 	  }
 	| term T_LBRACK expr T_RBRACK {
@@ -1502,7 +1531,7 @@
 		}
 	  }
 	| T_SIZEOF term					%prec T_SIZEOF {
-		if (($$ = $2 == NULL ? NULL : bldszof($2->tn_type)) != NULL)
+		if (($$ = $2 == NULL ? NULL : bldszoftrm($2)) != NULL)
 			chkmisc($2, 0, 0, 0, 0, 0, 1);
 	  }
 	| T_SIZEOF T_LPARN type_name T_RPARN		%prec T_SIZEOF {
@@ -1524,10 +1553,6 @@
 
 string2:
 	 T_STRING {
-		if (tflag) {
-			/* concatenated strings are illegal in traditional C */
-			warning(219);
-		}
 		$$ = $1;
 	  }
 	| string2 T_STRING {
@@ -1604,26 +1629,15 @@
 	} else {
 		i = (int)v->v_quad;
 		if (isutyp(t)) {
-			if ((u_quad_t)v->v_quad > INT_MAX) {
+			if ((u_quad_t)v->v_quad > UINT_MAX) {
 				/* integral constant too large */
 				warning(56);
 			}
 		} else {
-#ifdef XXX_BROKEN_GCC
-			if (v->v_quad > INT_MAX) {
-				/* integral constant too large */
-				warning(56);
-			}
-			else if (v->v_quad < INT_MIN) {
-				/* integral constant too large */
-				warning(56);
-			}
-#else
 			if (v->v_quad > INT_MAX || v->v_quad < INT_MIN) {
 				/* integral constant too large */
 				warning(56);
 			}
-#endif
 		}
 	}
 	free(v);
@@ -1636,6 +1650,9 @@
 	initerr = 0;
 	initsym = decl;
 
+	if (usedflg)
+		setuflg(decl, 0, 0);
+
 	switch (dcs->d_ctx) {
 	case EXTERN:
 		decl1ext(decl, initflg);
Index: usr.bin/xlint/lint1/decl.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/decl.c,v
retrieving revision 1.6
diff -u -r1.6 decl.c
--- usr.bin/xlint/lint1/decl.c	7 Jul 2004 12:24:00 -0000	1.6
+++ usr.bin/xlint/lint1/decl.c	25 Dec 2006 09:52:38 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: decl.c,v 1.23 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: decl.c,v 1.11 1995/10/02 17:34:16 jpo Exp $	*/
 
 /*
@@ -46,7 +47,7 @@
 /* contains various information and classification on types */
 ttab_t	ttab[NTSPEC];
 
-/* shared type structures for arithmtic types and void */
+/* shared type structures for arithmetic types and void */
 static	type_t	*typetab;
 
 /* value of next enumerator during declaration of enum types */
@@ -89,73 +90,73 @@
 		tspec_t	it_tspec;
 		ttab_t	it_ttab;
 	} ittab[] = {
-		{ SIGNED,   { 0, 0,
+		{ SIGNED,   { 0, 0, 0,
 			      SIGNED, UNSIGN,
 			      0, 0, 0, 0, 0, "signed" } },
-		{ UNSIGN,   { 0, 0,
+		{ UNSIGN,   { 0, 0, 0,
 			      SIGNED, UNSIGN,
 			      0, 0, 0, 0, 0, "unsigned" } },
-		{ CHAR,	    { CHAR_BIT, CHAR_BIT,
+		{ CHAR,	    { CHAR_BIT, CHAR_BIT, 20,
 			      SCHAR, UCHAR,
 			      1, 0, 0, 1, 1, "char" } },
-		{ SCHAR,    { CHAR_BIT, CHAR_BIT,
+		{ SCHAR,    { CHAR_BIT, CHAR_BIT, 20,
 			      SCHAR, UCHAR,
 			      1, 0, 0, 1, 1, "signed char" } },
-		{ UCHAR,    { CHAR_BIT, CHAR_BIT,
+		{ UCHAR,    { CHAR_BIT, CHAR_BIT, 20,
 			      SCHAR, UCHAR,
 			      1, 1, 0, 1, 1, "unsigned char" } },
-		{ SHORT,    { sizeof (short) * CHAR_BIT, 2 * CHAR_BIT,
+		{ SHORT,    { sizeof (short) * CHAR_BIT, 2 * CHAR_BIT, 30,
 			      SHORT, USHORT,
 			      1, 0, 0, 1, 1, "short" } },
-		{ USHORT,   { sizeof (u_short) * CHAR_BIT, 2 * CHAR_BIT,
+		{ USHORT,   { sizeof (u_short) * CHAR_BIT, 2 * CHAR_BIT, 30,
 			      SHORT, USHORT,
 			      1, 1, 0, 1, 1, "unsigned short" } },
-		{ INT,      { sizeof (int) * CHAR_BIT, 3 * CHAR_BIT,
+		{ INT,      { sizeof (int) * CHAR_BIT, 3 * CHAR_BIT, 40,
 			      INT, UINT,
 			      1, 0, 0, 1, 1, "int" } },
-		{ UINT,     { sizeof (u_int) * CHAR_BIT, 3 * CHAR_BIT,
+		{ UINT,     { sizeof (u_int) * CHAR_BIT, 3 * CHAR_BIT, 40,
 			      INT, UINT,
 			      1, 1, 0, 1, 1, "unsigned int" } },
-		{ LONG,     { sizeof (long) * CHAR_BIT, 4 * CHAR_BIT,
+		{ LONG,     { sizeof (long) * CHAR_BIT, 4 * CHAR_BIT, 50,
 			      LONG, ULONG,
 			      1, 0, 0, 1, 1, "long" } },
-		{ ULONG,    { sizeof (u_long) * CHAR_BIT, 4 * CHAR_BIT,
+		{ ULONG,    { sizeof (u_long) * CHAR_BIT, 4 * CHAR_BIT, 50,
 			      LONG, ULONG,
 			      1, 1, 0, 1, 1, "unsigned long" } },
-		{ QUAD,     { sizeof (quad_t) * CHAR_BIT, 8 * CHAR_BIT,
+		{ QUAD,     { sizeof (quad_t) * CHAR_BIT, 8 * CHAR_BIT, 60,
 			      QUAD, UQUAD,
 			      1, 0, 0, 1, 1, "long long" } },
-		{ UQUAD,    { sizeof (u_quad_t) * CHAR_BIT, 8 * CHAR_BIT,
+		{ UQUAD,    { sizeof (u_quad_t) * CHAR_BIT, 8 * CHAR_BIT, 60,
 			      QUAD, UQUAD,
 			      1, 1, 0, 1, 1, "unsigned long long" } },
-		{ FLOAT,    { sizeof (float) * CHAR_BIT, 4 * CHAR_BIT,
+		{ FLOAT,    { sizeof (float) * CHAR_BIT, 4 * CHAR_BIT, -1,
 			      FLOAT, FLOAT,
 			      0, 0, 1, 1, 1, "float" } },
-		{ DOUBLE,   { sizeof (double) * CHAR_BIT, 8 * CHAR_BIT,
+		{ DOUBLE,   { sizeof (double) * CHAR_BIT, 8 * CHAR_BIT, -1,
 			      DOUBLE, DOUBLE,
 			      0, 0, 1, 1, 1, "double" } },
-		{ LDOUBLE,  { sizeof (ldbl_t) * CHAR_BIT, 10 * CHAR_BIT,
+		{ LDOUBLE,  { sizeof (ldbl_t) * CHAR_BIT, 10 * CHAR_BIT, -1,
 			      LDOUBLE, LDOUBLE,
 			      0, 0, 1, 1, 1, "long double" } },
-		{ VOID,     { -1, -1,
+		{ VOID,     { -1, -1, -1,
 			      VOID, VOID,
 			      0, 0, 0, 0, 0, "void" } },
-		{ STRUCT,   { -1, -1,
+		{ STRUCT,   { -1, -1, -1,
 			      STRUCT, STRUCT,
 			      0, 0, 0, 0, 0, "struct" } },
-		{ UNION,    { -1, -1,
+		{ UNION,    { -1, -1, -1,
 			      UNION, UNION,
 			      0, 0, 0, 0, 0, "union" } },
-		{ ENUM,     { sizeof (int) * CHAR_BIT, 3 * CHAR_BIT,
+		{ ENUM,     { sizeof (int) * CHAR_BIT, 3 * CHAR_BIT, 40,
 			      ENUM, ENUM,
 			      1, 0, 0, 1, 1, "enum" } },
-		{ PTR,      { sizeof (void *) * CHAR_BIT, 4 * CHAR_BIT,
+		{ PTR,      { sizeof (void *) * CHAR_BIT, 4 * CHAR_BIT, -1,
 			      PTR, PTR,
 			      0, 1, 0, 0, 1, "pointer" } },
-		{ ARRAY,    { -1, -1,
+		{ ARRAY,    { -1, -1, -1,
 			      ARRAY, ARRAY,
 			      0, 0, 0, 0, 0, "array" } },
-		{ FUNC,     { -1, -1,
+		{ FUNC,     { -1, -1, -1,
 			      FUNC, FUNC,
 			      0, 0, 0, 0, 0, "function" } },
 	};
@@ -203,7 +204,7 @@
 /*
  * Returns a shared type structure vor arithmetic types and void.
  *
- * It's important do duplicate this structure (using duptyp() or tdupdyp())
+ * It's important to duplicate this structure (using duptyp() or tduptyp())
  * if it is to be modified (adding qualifiers or anything else).
  */
 type_t *
@@ -371,7 +372,7 @@
 		dcs->d_lmod = NOTSPEC;
 		if (!quadflg)
 			/* %s C does not support 'long long' */
-			(void)gnuism(265, tflag ? "traditional" : "ANSI");
+			(void)gnuism(265, "ANSI");
 	}
 
 	if (dcs->d_type != NULL && dcs->d_type->t_typedef) {
@@ -385,7 +386,7 @@
 		/* remeber specifiers "signed" and "unsigned" in dcs->d_smod */
 		if (dcs->d_smod != NOTSPEC)
 			/*
-			 * more then one "signed" and/or "unsigned"; print
+			 * more than one "signed" and/or "unsigned"; print
 			 * an error in deftyp()
 			 */
 			dcs->d_terr = 1;
@@ -427,9 +428,8 @@
 	case UNSIGN:
 		if (t2 == CHAR || t2 == SHORT || t2 == INT || t2 == LONG ||
 		    t2 == QUAD) {
-			if (!tflag)
-				/* modifying typedef with ... */
-				warning(5, ttab[t].tt_name);
+			/* modifying typedef with ... */
+			warning(5, ttab[t].tt_name);
 			td = duptyp(gettyp(mrgtspec(t2, t)));
 			td->t_typedef = 1;
 			return (td);
@@ -468,8 +468,6 @@
 		}
 		break;
 		/* LINTED (enumeration values not handled in switch) */
-	default:
-		break;
 	}
 
 	/* Anything other is not accepted. */
@@ -483,7 +481,7 @@
  * or enum tag if the typedef name is the first defined for this tag.
  *
  * If the tag is unnamed, the typdef name is used for identification
- * of this tag in lint2. Although its possible that more then one typedef
+ * of this tag in lint2. Although its possible that more than one typedef
  * name is defined for one tag, the first name defined should be unique
  * if the tag is unnamed.
  */
@@ -506,7 +504,7 @@
  * (and not the declarator) in the top element of the declaration stack.
  * Also detect multiple qualifiers of the same kind.
 
- * The rememberd qualifier is used by deftyp() to construct the type
+ * The remembered qualifier is used by deftyp() to construct the type
  * for all declarators.
  */
 void
@@ -518,15 +516,20 @@
 			warning(10, "const");
 		}
 		dcs->d_const = 1;
-	} else {
-		if (q != VOLATILE)
-			lerror("addqual() 1");
+	} else if (q == VOLATILE) {
 		if (dcs->d_volatile) {
 			/* duplicate "%s" */
 			warning(10, "volatile");
 		}
 		dcs->d_volatile = 1;
-	}
+	} else if (q == RESTRICT) {
+		if (dcs->d_restrict) {
+			/* duplicate "%s" */
+			warning(10, "restrict");
+		}
+		dcs->d_restrict = 1;
+	} else
+		lerror("addqual() 1");
 }
 
 /*
@@ -709,18 +712,14 @@
 			if (l == LONG) {
 				l = NOTSPEC;
 				t = DOUBLE;
-				if (!tflag)
-					/* use 'double' instead of ...  */
-					warning(6);
+				/* use 'double' instead of ...  */
+				warning(6);
 			}
 			break;
 		case DOUBLE:
 			if (l == LONG) {
 				l = NOTSPEC;
 				t = LDOUBLE;
-				if (tflag)
-					/* 'long double' is illegal in ... */
-					warning(266);
 			}
 			break;
 		case VOID:
@@ -818,14 +817,17 @@
 	int	elem, elsz;
 
 	elem = 1;
-	while (tp->t_tspec == ARRAY) {
+	while (tp && tp->t_tspec == ARRAY) {
 		elem *= tp->t_dim;
 		tp = tp->t_subt;
 	}
+	if (tp == NULL)
+		return (-1);
+
 	switch (tp->t_tspec) {
 	case FUNC:
 		/* compiler takes size of function */
-		lerror("%s", msgs[12]);
+		lerror(msgs[12]);
 		/* NOTREACHED */
 	case STRUCT:
 	case UNION:
@@ -851,7 +853,7 @@
 }
 
 /*
- * Get the alignment of the given Type in bits.
+ * Get the alignment of the given type in bits.
  */
 int
 getbound(type_t *tp)
@@ -859,9 +861,12 @@
 	int	a;
 	tspec_t	t;
 
-	while (tp->t_tspec == ARRAY)
+	while (tp && tp->t_tspec == ARRAY)
 		tp = tp->t_subt;
 
+	if (tp == NULL)
+		return (-1);
+
 	if ((t = tp->t_tspec) == STRUCT || t == UNION) {
 		a = tp->t_str->align;
 	} else if (t == FUNC) {
@@ -937,7 +942,7 @@
 				}
 				return;
 			} else if (tp->t_const || tp->t_volatile) {
-				if (sflag) {	/* XXX oder better !tflag ? */
+				if (sflag) {
 					/* function cannot return const... */
 					warning(228);
 				}
@@ -984,10 +989,11 @@
 			}
 		}
 		if (t == VOID && to != PTR) {
-			if (tp->t_const || tp->t_volatile) {
+			if (tp->t_const || tp->t_volatile || tp->t_restrict) {
 				/* inappropriate qualifiers with "void" */
 				warning(69);
 				tp->t_const = tp->t_volatile = 0;
+				tp->t_restrict = 0;
 			}
 		}
 		tpp = &tp->t_subt;
@@ -1028,8 +1034,8 @@
 		/*
 		 * bit field
 		 *
-		 * only unsigned und signed int are protable bit-field types
-		 *(at least in ANSI C, in traditional C only unsigned int)
+		 * only unsigned and signed int are portable bit-field types
+		 * (at least in ANSI C, in traditional C only unsigned int)
 		 */
 		if (t == CHAR || t == UCHAR || t == SCHAR ||
 		    t == SHORT || t == USHORT || t == ENUM) {
@@ -1040,12 +1046,19 @@
 				/* nonportable bit-field type */
 				warning(34);
 			}
+			if (isutyp(t))
+				tp->t_tspec = UINT;
+			else
+				tp->t_tspec = INT;
+
+			tp->t_isenum = 0;
 		} else if (t == INT && dcs->d_smod == NOTSPEC) {
 			if (pflag) {
 				/* nonportable bit-field type */
 				warning(34);
 			}
-		} else if (t != INT && t != UINT) {
+		} else if (t != INT && t != UINT && t != LONG &&
+		    t != ULONG && t != QUAD && t != UQUAD) {
 			/* illegal bit-field type */
 			error(35);
 			sz = tp->t_flen;
@@ -1149,6 +1162,8 @@
 	}
 	dsym->s_type = duptyp(dsym->s_type);
 	dsym->s_type->t_isfield = 1;
+	dsym->s_type->t_proto = 0;
+	dsym->s_type->t_isenum = 0;
 	dsym->s_type->t_flen = len;
 	dsym->s_field = 1;
 	return (dsym);
@@ -1194,7 +1209,7 @@
  * Followint 3 functions extend the type of a declarator with
  * pointer, function and array types.
  *
- * The current type is the Type built by deftyp() (dcs->d_type) and
+ * The current type is the type built by deftyp() (dcs->d_type) and
  * pointer, function and array types already added for this
  * declarator. The new type extension is inserted between both.
  */
@@ -1205,8 +1220,10 @@
 	pqinf_t	*npi;
 
 	tpp = &decl->s_type;
-	while (*tpp != dcs->d_type)
+	while (*tpp && *tpp != dcs->d_type)
 		tpp = &(*tpp)->t_subt;
+	if (*tpp == NULL)
+		return (decl);
 
 	while (pi != NULL) {
 		*tpp = tp = getblk(sizeof (type_t));
@@ -1231,8 +1248,10 @@
 	type_t	**tpp, *tp;
 
 	tpp = &decl->s_type;
-	while (*tpp != dcs->d_type)
+	while (*tpp && *tpp != dcs->d_type)
 		tpp = &(*tpp)->t_subt;
+	if (*tpp == NULL)
+	    return (decl);
 
 	*tpp = tp = getblk(sizeof (type_t));
 	tp->t_tspec = ARRAY;
@@ -1260,9 +1279,6 @@
 	type_t	**tpp, *tp;
 
 	if (dcs->d_proto) {
-		if (tflag)
-			/* function prototypes are illegal in traditional C */
-			warning(270);
 		args = nsfunc(decl, args);
 	} else {
 		osfunc(decl, args);
@@ -1285,8 +1301,10 @@
 	}
 
 	tpp = &decl->s_type;
-	while (*tpp != dcs->d_nxt->d_type)
+	while (*tpp && *tpp != dcs->d_nxt->d_type)
 		tpp = &(*tpp)->t_subt;
+	if (*tpp == NULL)
+	    return (decl);
 
 	*tpp = tp = getblk(sizeof (type_t));
 	tp->t_tspec = FUNC;
@@ -1392,7 +1410,7 @@
 sym_t *
 dname(sym_t *sym)
 {
-	scl_t	sc;
+	scl_t	sc = NOSCL;
 
 	if (sym->s_scl == NOSCL) {
 		dcs->d_rdcsym = NULL;
@@ -1455,7 +1473,7 @@
 			 * XXX somewhat ugly because we dont know whether
 			 * this is AUTO or EXTERN (functions). If we are
 			 * wrong it must be corrected in decl1loc(), where
-			 * we have the neccessary type information.
+			 * we have the necessary type information.
 			 */
 			sc = AUTO;
 			sym->s_def = DEF;
@@ -1518,7 +1536,7 @@
 type_t *
 mktag(sym_t *tag, tspec_t kind, int decl, int semi)
 {
-	scl_t	scl;
+	scl_t	scl = NOSCL;
 	type_t	*tp;
 
 	if (kind == STRUCT) {
@@ -1538,7 +1556,7 @@
 			/* a new tag, no empty declaration */
 			dcs->d_nxt->d_nedecl = 1;
 			if (scl == ENUMTAG && !decl) {
-				if (!tflag && (sflag || pflag))
+				if (sflag || pflag)
 					/* forward reference to enum type */
 					warning(42);
 			}
@@ -1571,7 +1589,7 @@
 			tp->t_enum = getblk(sizeof (enum_t));
 			tp->t_enum->etag = tag;
 		}
-		/* ist unvollstaendiger Typ */
+		/* is incomplete type */
 		setcompl(tp, 1);
 	}
 
@@ -1589,15 +1607,10 @@
 	if (tag->s_blklev < blklev) {
 		if (semi) {
 			/* "struct a;" */
-			if (!tflag) {
-				if (!sflag)
-					/* decl. introduces new type ... */
-					warning(44, scltoa(scl), tag->s_name);
-				tag = pushdown(tag);
-			} else if (tag->s_scl != scl) {
-				/* base type is really "%s %s" */
-				warning(45, scltoa(tag->s_scl), tag->s_name);
-			}
+			if (!sflag)
+				/* decl. introduces new type ... */
+				warning(44, scltoa(scl), tag->s_name);
+			tag = pushdown(tag);
 			dcs->d_nxt->d_nedecl = 1;
 		} else if (decl) {
 			/* "struct a { ..." */
@@ -1701,7 +1714,7 @@
  *
  * sym points to the enumerator
  * val is the value of the enumerator
- * impl is 1 if the the value of the enumerator was not explicit specified.
+ * impl is 1 if the value of the enumerator was not explicitly specified.
  */
 sym_t *
 ename(sym_t *sym, int val, int impl)
@@ -1775,6 +1788,12 @@
 		}
 	}
 
+	if (dsym->s_type->t_tspec == FUNC) {
+		if (noretflg)
+			dsym->s_noreturn = 1;
+	}
+	noretflg = 0;
+
 	/* Write the declaration into the output file */
 	if (plibflg && llibflg &&
 	    dsym->s_type->t_tspec == FUNC && dsym->s_type->t_proto) {
@@ -1789,7 +1808,6 @@
 	}
 
 	if ((rdsym = dcs->d_rdcsym) != NULL) {
-
 		/*
 		 * If the old symbol stems from a old style function definition
 		 * we have remembered the params in rdsmy->s_args and compare
@@ -1802,7 +1820,6 @@
 		}
 
 		if (!redec && !isredec(dsym, (warn = 0, &warn))) {
-
 			if (warn) {
 				/* redeclaration of %s */
 				(*(sflag ? error : warning))(27, dsym->s_name);
@@ -1921,7 +1938,7 @@
 		return(0);
 	if (rsym->s_scl == EXTERN && rsym->s_def == DEF) {
 		/*
-		 * All cases except "int a = 1; static int a;" are catched
+		 * All cases except "int a = 1; static int a;" are caught
 		 * above with or without a warning
 		 */
 		/* redeclaration of %s */
@@ -1952,7 +1969,7 @@
  * Checks if two types are compatible. Returns 0 if not, otherwise 1.
  *
  * ignqual	ignore qualifiers of type; used for function params
- * promot	promote left type; used for comparision of params of
+ * promot	promote left type; used for comparison of params of
  *		old style function definitions with params of prototypes.
  * *warn	set to 1 if an old style function declaration is not
  *		compatible with a prototype
@@ -1963,7 +1980,6 @@
 	tspec_t	t;
 
 	while (tp1 != NULL && tp2 != NULL) {
-
 		t = tp1->t_tspec;
 		if (promot) {
 			if (t == FLOAT) {
@@ -1971,22 +1987,25 @@
 			} else if (t == CHAR || t == SCHAR) {
 				t = INT;
 			} else if (t == UCHAR) {
-				t = tflag ? UINT : INT;
+				t = INT;
 			} else if (t == SHORT) {
 				t = INT;
 			} else if (t == USHORT) {
 				/* CONSTCOND */
-				t = INT_MAX < USHRT_MAX || tflag ? UINT : INT;
+				t = INT_MAX < USHRT_MAX ? UINT : INT;
 			}
 		}
 
 		if (t != tp2->t_tspec)
 			return (0);
 
-		if (tp1->t_const != tp2->t_const && !ignqual && !tflag)
+		if (tp1->t_const != tp2->t_const && !ignqual)
 			return (0);
 
-		if (tp1->t_volatile != tp2->t_volatile && !ignqual && !tflag)
+		if (tp1->t_volatile != tp2->t_volatile && !ignqual)
+			return (0);
+
+		if (tp1->t_restrict != tp2->t_restrict && !ignqual)
 			return (0);
 
 		if (t == STRUCT || t == UNION)
@@ -1998,7 +2017,7 @@
 		}
 
 		/* dont check prototypes for traditional */
-		if (t == FUNC && !tflag) {
+		if (t == FUNC) {
 			if (tp1->t_proto && tp2->t_proto) {
 				if (!eqargs(tp1, tp2, warn))
 					return (0);
@@ -2035,7 +2054,6 @@
 	a2 = tp2->t_args;
 
 	while (a1 != NULL && a2 != NULL) {
-
 		if (eqtype(a1->s_type, a2->s_type, 1, 0, warn) == 0)
 			return (0);
 
@@ -2134,7 +2152,7 @@
 }
 
 /*
- * Complets a type by copying the dimension and prototype information
+ * Completes a type by copying the dimension and prototype information
  * from a second compatible type.
  *
  * Following lines are legal:
@@ -2159,7 +2177,7 @@
 			if (dst->t_dim == 0 && src->t_dim != 0) {
 				*dstp = dst = duptyp(dst);
 				dst->t_dim = src->t_dim;
-				/* now a complete Typ */
+				/* now a complete type */
 				setcompl(dst, 0);
 			}
 		} else if (dst->t_tspec == FUNC) {
@@ -2208,13 +2226,7 @@
 	if ((t = sym->s_type->t_tspec) == ARRAY) {
 		sym->s_type = incref(sym->s_type->t_subt, PTR);
 	} else if (t == FUNC) {
-		if (tflag)
-			/* a function is declared as an argument: %s */
-			warning(50, sym->s_name);
 		sym->s_type = incref(sym->s_type, PTR);
-	} else if (t == FLOAT) {
-		if (tflag)
-			sym->s_type = gettyp(DOUBLE);
 	}
 
 	if (dcs->d_inline)
@@ -2238,7 +2250,7 @@
  * Does some checks for lint directives which apply to functions.
  * Processes arguments in old style function definitions which default
  * to int.
- * Checks compatiblility of old style function definition with previous
+ * Checks compatibility of old style function definition with previous
  * prototype.
  */
 void
@@ -2309,7 +2321,7 @@
 	}
 
 	/*
-	 * print a warning for each argument off an old style function
+	 * print a warning for each argument of an old style function
 	 * definition which defaults to int
 	 */
 	for (arg = args; arg != NULL; arg = arg->s_nxt) {
@@ -2322,7 +2334,7 @@
 	}
 
 	/*
-	 * If this is an old style function definition and a prototyp
+	 * If this is an old style function definition and a prototype
 	 * exists, compare the types of arguments.
 	 */
 	if (funcsym->s_osdef && funcsym->s_type->t_proto) {
@@ -2425,8 +2437,6 @@
 	 * functions may be declared inline at local scope, although
 	 * this has no effect for a later definition of the same
 	 * function.
-	 * XXX it should have an effect if tflag is set. this would
-	 * also be the way gcc behaves.
 	 */
 	if (dcs->d_inline) {
 		if (dsym->s_type->t_tspec == FUNC) {
@@ -2457,9 +2467,7 @@
 	}
 
 	if (dcs->d_rdcsym != NULL) {
-
 		if (dcs->d_rdcsym->s_blklev == 0) {
-
 			switch (dsym->s_scl) {
 			case AUTO:
 				/* automatic hides external declaration: %s */
@@ -2484,39 +2492,26 @@
 			default:
 				lerror("decl1loc() 1");
 			}
-
 		} else if (dcs->d_rdcsym->s_blklev == blklev) {
-
 			/* no hflag, because its illegal! */
 			if (dcs->d_rdcsym->s_arg) {
 				/*
-				 * if !tflag, a "redeclaration of %s" error
+				 * a "redeclaration of %s" error
 				 * is produced below
 				 */
-				if (tflag) {
-					if (hflag)
-						/* decl. hides parameter: %s */
-						warning(91, dsym->s_name);
-					rmsym(dcs->d_rdcsym);
-				}
 			}
 
 		} else if (dcs->d_rdcsym->s_blklev < blklev) {
-
 			if (hflag)
 				/* declaration hides earlier one: %s */
 				warning(95, dsym->s_name);
-
 		}
 
 		if (dcs->d_rdcsym->s_blklev == blklev) {
-
 			/* redeclaration of %s */
 			error(27, dsym->s_name);
 			rmsym(dcs->d_rdcsym);
-
 		}
-
 	}
 
 	if (initflg && !(initerr = chkinit(dsym))) {
@@ -2590,8 +2585,8 @@
 }
 
 /*
- * Print an error or a warning if the symbol cant be initialized due
- * to type/storage class. Returnvalue is 1 if an error has been
+ * Print an error or a warning if the symbol can't be initialized due
+ * to type/storage class. Return value is 1 if an error has been
  * detected.
  */
 static int
@@ -2664,7 +2659,7 @@
 	mblklev = 0;
 
 	/*
-	 * remove all informations about pending lint directives without
+	 * remove all information about pending lint directives without
 	 * warnings.
 	 */
 	glclup(1);
@@ -2701,11 +2696,7 @@
 	if (length(dsym->s_type, dsym->s_name) == 0 &&
 	    dsym->s_type->t_tspec == ARRAY && dsym->s_type->t_dim == 0) {
 		/* empty array declaration: %s */
-		if (tflag) {
-			warning(190, dsym->s_name);
-		} else {
-			error(190, dsym->s_name);
-		}
+		error(190, dsym->s_name);
 	}
 }
 
@@ -2993,7 +2984,7 @@
 				warning(307, sym->s_name);
 			}
 		}
-		if (!tflag && sym->s_def == TDEF && sym->s_type->t_const) {
+		if (sym->s_def == TDEF && sym->s_type->t_const) {
 			STRUCT_ASSIGN(curr_pos, sym->s_dpos);
 			/* const object %s should have initializer */
 			warning(227, sym->s_name);
@@ -3007,7 +2998,7 @@
 	if (sym->s_def == TDEF) {
 		if (sym->s_type->t_tspec == FUNC)
 			/*
-			 * this can happen if an syntax error occured
+			 * this can happen if a syntax error occurred
 			 * after a function declaration
 			 */
 			return;
@@ -3015,7 +3006,7 @@
 		if (length(sym->s_type, sym->s_name) == 0 &&
 		    sym->s_type->t_tspec == ARRAY && sym->s_type->t_dim == 0) {
 			/* empty array declaration: %s */
-			if (tflag || (sym->s_scl == EXTERN && !sflag)) {
+			if (sym->s_scl == EXTERN && !sflag) {
 				warning(190, sym->s_name);
 			} else {
 				error(190, sym->s_name);
Index: usr.bin/xlint/lint1/emit.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/emit.c,v
retrieving revision 1.5
diff -u -r1.5 emit.c
--- usr.bin/xlint/lint1/emit.c	7 Jul 2004 12:13:26 -0000	1.5
+++ usr.bin/xlint/lint1/emit.c	25 Dec 2006 09:59:26 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: emit.c,v 1.9 2005/12/10 18:58:50 martin Exp $	*/
 /*	$NetBSD: emit.c,v 1.2 1995/07/03 21:24:00 cgd Exp $	*/
 
 /*
@@ -32,8 +33,6 @@
  *
  * $FreeBSD: src/usr.bin/xlint/lint1/emit.c,v 1.1.1.1.8.1 2001/03/04 09:27:26 kris Exp $
  * $DragonFly: src/usr.bin/xlint/lint1/emit.c,v 1.5 2004/07/07 12:13:26 asmodai Exp $
- *
- * $NetBSD: emit.c,v 1.2 1995/07/03 21:24:00 cgd Exp $
  */
 
 #include <stdio.h>
@@ -61,11 +60,11 @@
 {
 	loname = name;
 
-	/* Ausgabedatei oeffnen */
+	/* open output file */
 	if ((lout = fopen(name, "w")) == NULL)
 		err(1, "cannot open '%s'", name);
 
-	/* Ausgabepuffer anlegen */
+	/* generate output buffer */
 	ob.o_len = 1024;
 	ob.o_end = (ob.o_buf = ob.o_nxt = xmalloc(ob.o_len)) + ob.o_len;
 }
@@ -197,9 +196,10 @@
 void
 outint(int i)
 {
-	if ((ob.o_end - ob.o_nxt) < 3 * sizeof (int))
+	if ((ob.o_end - ob.o_nxt) < 12)
 		outxbuf();
-	ob.o_nxt += sprintf(ob.o_nxt, "%d", i);
+	snprintf(ob.o_nxt, ob.o_end - ob.o_nxt, "%d", i);
+	ob.o_nxt += strlen(ob.o_nxt);
 }
 
 /*
Index: usr.bin/xlint/lint1/emit1.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/emit1.c,v
retrieving revision 1.5
diff -u -r1.5 emit1.c
--- usr.bin/xlint/lint1/emit1.c	7 Jul 2004 12:13:26 -0000	1.5
+++ usr.bin/xlint/lint1/emit1.c	25 Dec 2006 10:01:22 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: emit1.c,v 1.6 2005/11/29 19:38:09 cloder Exp $	*/
 /*	$NetBSD: emit1.c,v 1.4 1995/10/02 17:21:28 jpo Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: emit1.c,v 1.4 1995/10/02 17:21:28 jpo Exp $
  * $DragonFly: src/usr.bin/xlint/lint1/emit1.c,v 1.5 2004/07/07 12:13:26 asmodai Exp $
  */
 
@@ -404,7 +404,7 @@
 			if (isityp(t = arg->tn_type->t_tspec)) {
 				/*
 				 * XXX it would probably be better to
-				 * explizitly test the sign
+				 * explicitly test the sign
 				 */
 				if ((q = arg->tn_val->v_quad) == 0) {
 					/* zero constant */
@@ -418,13 +418,17 @@
 				}
 				outint(n);
 			}
-		} else if (arg->tn_op == AMPER &&
-			   arg->tn_left->tn_op == STRING &&
-			   arg->tn_left->tn_strg->st_tspec == CHAR) {
-			/* constant string, write all format specifiers */
-			outchar('s');
-			outint(n);
-			outfstrg(arg->tn_left->tn_strg);
+		} else {
+			if (arg->tn_op == CVT && !arg->tn_cast)
+				arg = arg->tn_left;
+			if (arg->tn_op == AMPER &&
+			    arg->tn_left->tn_op == STRING &&
+			    arg->tn_left->tn_strg->st_tspec == CHAR) {
+				/* constant string, write format specifiers */
+				outchar('s');
+				outint(n);
+				outfstrg(arg->tn_left->tn_strg);
+			}
 		}
 
 	}
@@ -448,7 +452,7 @@
 
 /*
  * extracts potential format specifiers for printf() and scanf() and
- * writes them, enclosed in "" and qouted if necessary, to the output buffer
+ * writes them, enclosed in "" and quoted if necessary, to the output buffer
  */
 static void
 outfstrg(strg_t *strg)
